
import java.util.ArrayList;

class HashDict {
     
    private class StrIntPair {
	    private String _word;
	    private int _count;
	    public StrIntPair(String w, int c) {_word = w; _count = c;}
	    public String getWord() { return _word; }
	    public int getCount() { return _count; }
	    public void setCount(int c) { _count = c; }
    }

    private class Cell {
       private String data_;
       private int count_;
       private Cell next_;
       public Cell(String s, Cell n) {data_ = s; next_ = n;}
       public String data() {return data_;}
       public int count() {return count_;}
       public void count(int c) {count_ = c;}
       public Cell next() {return next_;}
       //public void setData(String s) {data_ = s;}
       //public void setNext(Cell c)   {next_ = c;}
    }

    private static int HMAX = 127;

    private Cell[] HTable; 

    public HashDict() {
	    HTable = new Cell[HMAX];
	    for (int i=0; i<HMAX; i++) HTable[i] = null;
    }

    private int hash(String s) {
	    int val = s.hashCode() % HMAX;
	    if (val < 0) val += HMAX;
	    return val;
    }

    public boolean containsKey(String w) {
	    int h = hash(w);
	    //System.out.printf("hash(%s) = %d%n", w, h);
	    Cell p = HTable[h];
	    boolean found = false;
	    int i = 0;
	    while (p!=null && !found) {
	        if (p.data().equals(w)) {
		        found = true;		// L[i] is the cell we're looking for
	        } else {
	            p = p.next();			// keep looking
	        }
	    }
	    return found;
    }

    public int get(String w) {
	return 0;			// like the above, except return L[i].getCount()
    }

    // Put is a loop like the previous two, except if found==true we do L[i].setCount(count)
    // and if found==false we do L.Add(new StrListPair(w,count))
    public void put(String w, int count) {	
    }

    // standard hash-table traversal:
    //    for (int i=0; i<HMAX; i++)
    //        print each item in List HTable[i]

    public void print() {
    }

}